
#include "ell/MinimumMapping.hh"

#include <ell/Walk.hh>
#include <ell/StateCollector.hh>

namespace ell {

	MM_GradientWalk::MM_GradientWalk()
	{
	}

	MM_GradientWalk::~MM_GradientWalk()
	{
	}

	State*
	MM_GradientWalk::getLocalMin( const State * const toMap ) const {
		  // set up state collector that will contain the minimum as the last 
		  // added state
		SC_Counting sc;
		  // perform the gradient walk
		WalkGradient::walkGradient(
						toMap, 
						&sc
						);
		  // return a clone of the last added State = local minimum
		return sc.getLastAdded()->clone();
	}

} // namespace ell

